/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010  Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * fac.t 
 * program to check the invariant of the factorial program fac
 * which is started when this file is loaded
 *
 */
 
load "../library/conversion".
load "../library/exprog".

/* prog fac 0 */

set print_states = false.

define seed = 1+ random mod 9.

define get_var(X,Y) = 
{
    exists T : {
        get2(T) and output(atime(T)) and
        if avar(T)=X then {Y=strint(aval(T))}        
        else empty
    }
}.

define check(Z,X,Y) = {
    {
        skip and get_var("fac",X) and stable(X) and
        if X= Z then {
          format("!:: Pass Prog %7d Prop %7d\n", X, Z)
        } else {
          format("!:: Fac: Prog %d Prop %d\n", X, Z)
        }
    };
    { skip and get_var("y",Y) and  stable(X) and stable(Y)
          };
    {
        skip and  stable(Y)
            }
    
    
}.



define fac_rel(Y) = {
   if Y=seed then Y
          else Y * fac_rel(Y+1)
}.

/* run */ define test() = {
  exists Fac,Y : {
     prog_send(seed);
     check(1,Fac,Y); 
    if seed>1 then {
        while Y>1 do
            check(fac_rel(Y),Fac,Y)
    } else empty
  }
}.





