/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Sum the nodes of a binary tree.  
 * Ben Moszkowski 
 */

load "misc".

define sum_tree(Tree) = {
    if is_integer(Tree) then empty
    else {
	sum_subtree(Tree,0);
	sum_subtree(Tree,1);
	{
	    skip and Tree:= Tree[0]+Tree[1]
	}
    }
}.

/* Sum the i-th subtree.  Keep the other subtree stable */
define sum_subtree(Tree,i) = {
    sum_tree(Tree[i])
    and stable(struct(Tree))
    and stable(Tree[1-i])
}.

define sum_test(t) = {
    exists Tree : {
	Tree=t
	and sum_tree(Tree)
        and always format("Tree=%t\n",Tree)
    }
}.


define sum_test1 = 1.

define sum_test2 = [1,2].

define sum_test3 = [[1,[2,3]],[4,5]].

define sum_test4 = [[[1,1],[1,1]],[[1,1],[1,1]]].

define sum_test5 = [[sum_test3,sum_test3],sum_test3].


/* run */ define run_test() = {
 {format("******* test 1 *******\n") and sum_test(sum_test1)};
 {format("******* test 2 *******\n") and sum_test(sum_test2)};
 {format("******* test 3 *******\n") and sum_test(sum_test3)};
 {format("******* test 4 *******\n") and sum_test(sum_test4)};
 {format("******* test 5 *******\n") and sum_test(sum_test5)}
}.
